import { DialogSOP } from '../../libappsop/dialogsop';
import { DropDownListSOP } from '../../libappsop/dropdownlistsop';
import { EditFieldSOP } from '../../libappsop/editfieldsop';

export interface DialogPostponeForecastFields {
  PostponeToPeriod?: string;
  PostponeQuantity?: string;
}

export class DialogPostponeForecast extends DialogSOP<DialogPostponeForecastFields> {
  public static readonly title = 'Postpone sales demand';
  public ddlPostponeToPeriod = new DropDownListSOP('DropDownListPeriod');
  public efPostponeQuantity = new EditFieldSOP('EditFieldPostponeQty');

  public constructor() {
    super('DialogCreateEditPostponementSpecification');

    // Set UI element mapping to pair the UI name to the UI element for use in DialogSOP to find the UI object to set value or verify value
    // This prevents each new Dialog to duplicate code just to set/verify UI element value
    this._uiMap.set('PostponeToPeriod', this.ddlPostponeToPeriod);
    this._uiMap.set('PostponeQuantity', this.efPostponeQuantity);
  }
}
